<template>
  <ob-main-template
    :top-level-members="topLevelMembers"
    version="V40.15 15.10.2020"
    :lang-icon="isLangIcon"
    @logout="logoutFunction"
    @profile="goToProfile"
    @settings="goToSettings"
    @change-locale="changeLocale"
    @setCompany="goToCompany"
  >
    <router-view />
  </ob-main-template>
</template>

<script>
import Vue from 'vue'
import VueRouter from 'vue-router'
import obMainTemplate from '@/obComponents/obMainTemplate'
import Developing from './pages/Developing'
import Table from './pages/table'
import Constructor from './pages/constructor_page'

window.OBOZ_CONFIG = {
  OBOZ_API_HOST: 'https://dev.oboz.app',
  CS: 'f17f413f-91ba-473a-b29a-c26b90c3e93b'
}

Vue.directive('scroll', {
  inserted: function (el, binding) {
    let f = function (evt) {
      if (binding.value(evt, el)) {
        window.removeEventListener('scroll', f)
      }
    }
    window.addEventListener('scroll', f)
  }
})

Vue.prototype.$eventGlobal = new Vue()

Vue.use(VueRouter)
let router = new VueRouter({
  mode: 'history',
  linkActiveClass: 'is-active',
  directives: {
    scroll
  },
  routes: [
    {
      path: '/table',
      name: 'table',
      component: Table,
      meta: {
        title: 'Страница с таблицей',
        guestOnly: true
      }
    }, {
      path: '/constructor',
      name: 'Constructor',
      component: Constructor,
      meta: {
        title: 'Страница с Constructor-ом',
        guestOnly: true
      }
    },
    {
      path: '/developing',
      name: 'Developing',
      component: Developing,
      meta: {
        title: 'В процессе разработки'
      }
    },
    {
      path: '*',
      redirect: { name: 'Test' }
    }
  ]
})

const topLevelMembers = [
  {
    caption: 'Мониторинг',
    to: { name: 'data-grid' },
    only: ['moderator'],
    members: [
      {
        title: 'Роли',
        to: { name: 'Home' }
      },
      {
        title: 'Пагинация',
        to: { name: 'PaginationTest' }
      },
      {
        title: 'Организации',
        to: { name: 'Contractors' }
      },
      {
        title: 'Доступы',
        to: { name: 'Access' }
      },
      {
        title: 'Роли пользователей',
        to: { name: 'UserRoles' }
      },
      {
        title: 'Пользователи',
        to: { name: 'Users' }
      },
      {
        title: 'Логистические домены',
        to: { name: 'Domains' }
      }
    ]
  },
  {
    caption: 'Документы',
    href: '/docs',
    only: ['client', 'urmom']
  },
  {
    caption: 'Аналитика',
    href: '/analytics'
  },
  {
    caption: 'Оплаты',
    href: '/payments'
  },
  {
    caption: 'Договор',
    disabled: true,
    href: '/contract'
  },
  {
    caption: 'Справочники',
    members: [
      {
        caption: 'Роли',
        href: '/somename',
        only: ['client', 'urmom']
      },
      {
        caption: 'Организации',
        to: { name: 'Test' },
        members: [
          {
            title: 'Роewли',
            to: { name: 'Home' },
            only: ['urmom']
          },
          {
            title: 'Организewации',
            to: { name: 'Contractors' }
          },
          {
            title: 'Достуewпы',
            to: { name: 'Access' }
          }
        ]
      }
    ]
  },
  {
    caption: 'Настройки',
    href: 'settings'
  }
]

const events = {
  'Access': {
    count: 0
  },
  'Home': {
    count: 2
  },
  'Contractors': {
    count: 99
  }
}

console.log(events)

export default {
  name: 'App',
  router,
  components: {
    obMainTemplate
  },
  data () {
    return {
      topLevelMembers: topLevelMembers,
      currentComponentIndex: 0,
      isLangIcon: true // default = TRUE
    }
  },
  created () {
    this.$eventGlobal.$on('getComponentId', this.setComponentId)
  },
  methods: {
    logoutFunction () {
      // eslint-disable-next-line no-console
      document.cookie = "auth_token='';expires=Thu, 01 Jan 1970 00:00:01 GMT;"
      alert('logout! token has been deleted')
    },
    goToProfile () {
      console.log('profile')
    },
    goToSettings () {
      console.log('settings')
    },
    goToCompany (val) {
      console.log('company', val)
    },
    changeLocale (lang) {
      console.log('lang', lang)
    },
    setComponentId (data) {
      let path = this.$route.path.split('/')

      path = path[2] ? path[2] : path[1]

      this.$eventGlobal.$emit('setComponentId', {
        uuid: data.uuid,
        id: `${path}_${data.tag}_${this.currentComponentIndex++}`
      })
    }
  }
}
</script>
